package cn.com.qmth.examcloud.core.examwork.dao;

import cn.com.qmth.examcloud.api.commons.security.bean.UserType;
import cn.com.qmth.examcloud.core.examwork.dao.entity.UserNoticeEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import java.util.List;

public interface UserNoticeRepo extends JpaRepository<UserNoticeEntity, Long>,
        QueryByExampleExecutor<UserNoticeEntity>, JpaSpecificationExecutor<UserNoticeEntity> {
    List<UserNoticeEntity> findByRootOrgIdAndUserTypeAndUserId(Long rootOrgId,UserType userType,Long userId);

    List<UserNoticeEntity> findByRootOrgIdAndUserTypeAndUserIdAndRead(Long rootOrgId,UserType userType,Long userId,Boolean read);

    @Modifying
    @Query("update EC_E_USER_NOTICE set read = 1 where notice_id in (?1) and user_type = ?2 and user_id = ?3")
    int updateNoticeReadStatus(String noticeId, UserType userType, Long UserId);
}
